//xsetaseta@gmail.com
//comSeta prueba
//sof SERIE  IntExternaPin2
//sof SERIE 75,150,300,600,1200,2400,4800

#include <avr/io.h>
#include <avr/interrupt.h>

//Definición variables Serie_Seta intExterna2
bool SDatoEstado = 0;
static unsigned long Stimeu;
unsigned int SRetardo;
unsigned int SRetardoMax;
bool SBstart = 0;
byte SNumBit;
unsigned int Sdato = 0;
unsigned int  SDatoSerie;
unsigned long timeMax;
//__________________________________


void setup(void)
{
  Serial.begin(9600);
  Serial.println("Serie_IntExternoPIN2");

  SetupSerie2(4800); //Entrada por Pin 2
}
//
void loop(void)
{
  char c;
  if (SerialAvailable())
  {
    c = SerialGet();
    Serial.print(c);
  }
}


// Interrupt INT0 vector Pin 2
ISR(INT0_vect)
{
  static unsigned long diferencia;
  static unsigned long time;
  static bool ahora = 0;
  byte z, contador;

  time = micros();
  timeMax = 0;

  if ( SBstart == 0)
  {
    SBstart = 1;
    Sdato = 0;
    SNumBit = 0;
    ahora = 0;
  }
  else
  {
    diferencia = time - Stimeu;
    diferencia = diferencia / SRetardo;
    contador = diferencia;

    for (z = 0; z < contador; z++)
    {
      Sdato = Sdato >> 1;
      if (ahora == 1) Sdato |= 256;
      SNumBit++;
    }

    if (ahora == 0) ahora = 1;  else  ahora = 0;

    if (SNumBit > 9)
    {
      SNumBit = 0;
      SDatoEstado = 1;
      SDatoSerie = Sdato;
      Sdato = 0;
    }
  }
  Stimeu = time;
}


//____________________________________________
bool SetupSerie2(unsigned int  baud)
{
  pinMode(2, INPUT);
  digitalWrite(2, HIGH); // Enable pull-up resistor
  cli();                 // Enable global interrupts
  EIMSK |= (1 << INT0);  // Enable external interrupt INT0
  EICRA |= (1 << ISC00); // Trigger INT0 on Change
  sei();

  switch (baud)
  {
    case 75:
      SRetardo = 12000;
      SRetardoMax = 20000;
      break;
    case 150:
      SRetardo = 6000;
      SRetardoMax = 20000;
      break;
    case 300:
      SRetardo = 3000;
      SRetardoMax = 20000;
      break;
    case 600:
      SRetardo = 1500;
      SRetardoMax = 5000;
      break;
    case 1200:
      SRetardo = 750;
      SRetardoMax = 5000;
      break;
    case 2400:
      SRetardo = 375;
      SRetardoMax = 2500;
      break;
    case 4800:
      SRetardo = 187;
      SRetardoMax = 1250;
      break;
    // case 9600:
    //   SRetardo = 96;
    //   SRetardoMax = 1000;
    //   break;

    default:
      //error baudios
      return (1);
  }
  return(0);
}

byte SerialGet(void)
{
  SDatoEstado = 0;
  return (SDatoSerie & 0x00FF);
}

byte SerialAvailable(void)
{
 
  if (SBstart > 0 )
  {
    timeMax++;
    if (timeMax > SRetardoMax)
    {
      timeMax = 0;
      SBstart = 0;
      SNumBit = 0;
      SDatoEstado = 1;
      Sdato = Sdato >> 1;
      SDatoSerie = Sdato;
      Sdato = 0;
    }
  }
  return (SDatoEstado);
}



