//xsetaseta@gmail.com
//comSeta prueba
//sof SERIE 75,150,300,600,1200,2400,4800

#include <avr/io.h>
#include <avr/interrupt.h>


//Definición variables Serie_Seta
byte SInputSerial;
byte SDatoSerie;
bool SDatoEstado = 0;
char SRetardo;
unsigned int SRetardoStop;
unsigned int SRetardoMax;
//___________________________________

void setup()
{ 
  Serial.begin(9600);
  Serial.println("_Se_");

  SetupSerie(2,4800);
  Serial.println(SRetardo,DEC);
  Serial.println(SRetardoStop);
  Serial.println(SRetardoMax);

  Serial.println("_YA_");
}

 void loop(void)
{
  char c;
  if (SerialAvailable())
  {
    c = SerialGet();
    Serial.print(c);
  }
}


bool SetupSerie(byte input, unsigned int  baud)
{
  unsigned int Scontador;
  SInputSerial = input;
  pinMode(SInputSerial, INPUT);

  switch (baud)
  {
    case 75:
      SRetardo = 29;
      Scontador = 7200;
      break;
    case 150:
      SRetardo = 29;
      Scontador = 3600;
      break;
    case 300:
      SRetardo = 29;
      Scontador = 1800;
      break;
    case 600:
      SRetardo = 29;
      Scontador = 900;
      break;
    case 1200:
      SRetardo = 29;
      Scontador = 450;
      break;
    case 2400:
      SRetardo = 29;
      Scontador = 225;
      break;
    case 4800:
      SRetardo = 14;
      Scontador = 225;
      break;

    default:
      //error baudios
      return (1);
  }

  SRetardoStop = SRetardo * 10;
  SRetardoMax = SRetardo * 14;
  // initialize Timer1
  cli();          // disable global interrupts
  TCCR1A = 0;     // set entire TCCR1A register to 0
  TCCR1B = 0;     // same for TCCR1B
  TCCR1B |= (1 << WGM12); // turn on CTC mode:
  TCCR1B |= (1 << CS10);  //sin prescaler
  OCR1A = Scontador;   //contador
  TIMSK1 |= (1 << OCIE1A); // enable timer compare interrupt:
  sei();          // enable global interrupts
  return (0);
}


ISR(TIMER1_COMPA_vect)
{
  static bool inicio = 1;
  static unsigned int contador;
  static unsigned int Acontador;
  static bool estado;
  static bool estadoanterior;
  static bool Bstart = 0;
  static bool cambio;
  static byte dato = 0;
  static char NumBit;
  static byte CuBit ;

  estado = digitalRead(SInputSerial);
  //estado=PIND & 4; Mas rápido para pin 2
  if (estado != estadoanterior)cambio = 1;
  estadoanterior = estado;

  if (cambio == 1) { Bstart = 1; Acontador = 0; }

  Acontador++;
  if (Acontador > SRetardoMax )
  {
    inicio = 0;  CuBit = 0; Bstart = 0; Acontador = 0; 
    contador = 0; NumBit = -3; dato = 0; SDatoEstado = 0;
  }

  if (Bstart == 1)
  {
    NumBit++;
   // PORTB ^= _BV(PB5);
    if (NumBit > SRetardo)
    {
      NumBit = 0;
      CuBit++;
      if (CuBit > 8) goto salto1;
      dato >>= 1;
      if (estado) dato |= 128;
    }
salto1:
    contador++;
    if (contador > SRetardoStop || CuBit > 8)
    {
      contador = 0;  Bstart = 0;  Acontador = 0; 
      NumBit = -3; CuBit = 0;  SDatoSerie = dato;
      if (inicio == 0)SDatoEstado = 1;
    } 
  }

  cambio = 0;
}


byte SerialGet(void)
{
  SDatoEstado = 0;
  return (SDatoSerie);
}

byte SerialAvailable(void)
{
 return (SDatoEstado);
}

